import { EOChild } from 'mve-core/childrenBuilder';
import { mve } from 'mve-core/util';
import { FlatTree } from './flatTree';
/**
 * 创建视图
 * @param me
 * @param router
 * @param createRoutes
 * @param other
 * @returns
 */
export declare function routerView<T>(me: mve.LifeModel, router: Router<T>, createRoutes: {
    [key in keyof T]: CreateSubRouter<T[key]>;
}, other?: {
    notFoundView?: Router<any>;
}): EOChild<Node>;
export interface QueryParam {
    [key: string]: string | string[];
}
export interface RouterParam {
    path: string[];
    query: QueryParam;
}
export declare type CreateSubRouter<T> = (parentPath: string[]) => Router<T>;
export declare class Router<T> {
    readonly parentPath: string[];
    private fun;
    readonly param: mve.Value<RouterParam>;
    constructor(parentPath: string[], fun: (me: mve.LifeModel, router: Router<T>) => EOChild<Node>);
    current(): keyof T;
    render(me: mve.LifeModel): EOChild<Node>;
    /**
     * 生成合适的路由
     * @param path
     * @param query
     * @returns
     */
    href<K extends keyof FlatRouter<T>>(path: K, query: (FlatRouter<T>[K] extends QueryWrapper ? FlatRouter<T>[K]['value'] : never)): string;
    /**
     * 中能在自己的下游路径漫游
     * @param path
     * @param query
     */
    go<K extends keyof FlatRouter<T>>(path: K, query: (FlatRouter<T>[K] extends QueryWrapper ? FlatRouter<T>[K]['value'] : never)): void;
}
export declare function queryToString(q?: QueryParam): string;
export declare function createRouter<T>(fun: (me: mve.LifeModel, router: Router<T>) => EOChild<Node>): CreateSubRouter<T>;
export declare function hashToParam(hash: string): RouterParam;
export declare function locationHashChange(route: Router<any>): void;
export declare function locationHashBind(route: Router<any>): void;
export declare class QueryWrapper<T extends QueryParam = {}> {
    value: T;
    constructor(value: T);
}
export declare type FlatRouter<T> = FlatTree<T, QueryWrapper, '/'>;
